/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setSizes = async (req, res, next) => {
  try {
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const { height, weight, size } = req.body
    if (!height || !weight || !size) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }

    // جستجوی کاربر با شماره موبایل ارسالی
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)
    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    user.height = height
    user.weight = weight
    user.size = size
    await user.save()

    return res.json({
      message: 'سایز با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}

const updateSizes = async (req, res, next) => {
  try {
    const { height, weight, size } = req.body

    if (!height || !weight || !size) {
      return res.status(422).json({
        error: true,
        message: 'اطلاعات ارسالی اشتباه است'
      })
    }
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')
    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const userId = decodedToken.id
    // جستجوی کاربر
    const user = await UserModel.findById(userId)

    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربر یافت نشد'
      })
    }

    user.height = height
    user.weight = weight
    user.size = size
    await user.save()

    return res.json({
      message: 'سایز با موفقیت به‌روزرسانی شد'
    })
  } catch (error) {
    next(error)
  }
}
module.exports = {
  setSizes, updateSizes
}
